Group Orientation
Users can group appointments by resources. This demo declares a single resource—Priority. Refer to the following demo for more information about resources and their configuration: Resources.
To group appointments by resources, specify the groups[] array. Each element of this array is the fieldExpr of a corresponding resource kind. The order of group headers in the UI is the same as items in the resource instances array. If the groups[] array contains more than one element, groups are nested.
The Scheduler can arrange group headers vertically (in a column) or horizontally (in a row). Use the views.groupOrientation property to set a custom orientation for specific views. This demo shows two Work Week views with different group orientations.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
$('#scheduler').dxScheduler({
timeZone: 'America/Los_Angeles',
dataSource: data,
views: [{
type: 'workWeek',
name: 'Vertical Grouping',
groupOrientation: 'vertical',
cellDuration: 60,
intervalCount: 2,
}, {
type: 'workWeek',
name: 'Horizontal Grouping',
groupOrientation: 'horizontal',
cellDuration: 30,
intervalCount: 2,
}],
currentView: 'Vertical Grouping',
crossScrollingEnabled: true,
currentDate: new Date(2021, 3, 21),
startDayHour: 9,
endDayHour: 16,
groups: ['priorityId'],
resources: [
{
fieldExpr: 'priorityId',
allowMultiple: false,
dataSource: priorityData,
label: 'Priority',
},
],
showCurrentTimeIndicator: false,
showAllDayPanel: false,
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
</div>
</body>
</html>
.dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
const data = [
{
text: 'Website Re-Design Plan',
priorityId: 2,
startDate: new Date('2021-04-19T16:30:00.000Z'),
endDate: new Date('2021-04-19T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 1,
startDate: new Date('2021-04-22T17:00:00.000Z'),
endDate: new Date('2021-04-22T19:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
startDate: new Date('2021-04-19T20:00:00.000Z'),
endDate: new Date('2021-04-19T22:30:00.000Z'),
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
startDate: new Date('2021-04-20T17:00:00.000Z'),
endDate: new Date('2021-04-20T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
startDate: new Date('2021-04-20T19:00:00.000Z'),
endDate: new Date('2021-04-20T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
startDate: new Date('2021-04-19T20:00:00.000Z'),
endDate: new Date('2021-04-19T22:15:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
startDate: new Date('2021-04-20T16:00:00.000Z'),
endDate: new Date('2021-04-20T19:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
startDate: new Date('2021-04-21T19:00:00.000Z'),
endDate: new Date('2021-04-21T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
startDate: new Date('2021-04-19T16:00:00.000Z'),
endDate: new Date('2021-04-19T18:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
startDate: new Date('2021-04-22T18:00:00.000Z'),
endDate: new Date('2021-04-22T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
startDate: new Date('2021-04-21T18:00:00.000Z'),
endDate: new Date('2021-04-21T20:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
startDate: new Date('2021-04-23T17:00:00.000Z'),
endDate: new Date('2021-04-23T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
startDate: new Date('2021-04-23T16:00:00.000Z'),
endDate: new Date('2021-04-23T22:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
startDate: new Date('2021-04-23T23:30:00.000Z'),
endDate: new Date('2021-04-24T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
startDate: new Date('2021-04-23T19:20:00.000Z'),
endDate: new Date('2021-04-23T21:00:00.000Z'),
}, {
text: 'Google AdWords Strategy',
priorityId: 1,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T19:00:00.000Z'),
}, {
text: 'Rollout of New Website and Marketing Brochures',
priorityId: 1,
startDate: new Date('2021-04-26T20:00:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Non-Compete Agreements',
priorityId: 2,
startDate: new Date('2021-04-27T20:00:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Approve Hiring of John Jeffers',
priorityId: 2,
startDate: new Date('2021-04-27T16:00:00.000Z'),
endDate: new Date('2021-04-27T19:00:00.000Z'),
}, {
text: 'Update NDA Agreement',
priorityId: 1,
startDate: new Date('2021-04-27T18:00:00.000Z'),
endDate: new Date('2021-04-27T21:15:00.000Z'),
}, {
text: 'Update Employee Files with New NDA',
priorityId: 1,
startDate: new Date('2021-04-30T16:00:00.000Z'),
endDate: new Date('2021-04-30T18:45:00.000Z'),
}, {
text: 'Submit Questions Regarding New NDA',
priorityId: 1,
startDate: new Date('2021-04-28T17:00:00.000Z'),
endDate: new Date('2021-04-28T18:30:00.000Z'),
}, {
text: 'Submit Signed NDA',
priorityId: 1,
startDate: new Date('2021-04-28T20:00:00.000Z'),
endDate: new Date('2021-04-28T22:00:00.000Z'),
}, {
text: 'Review Revenue Projections',
priorityId: 2,
startDate: new Date('2021-04-28T18:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Comment on Revenue Projections',
priorityId: 2,
startDate: new Date('2021-04-26T17:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Provide New Health Insurance Docs',
priorityId: 2,
startDate: new Date('2021-04-30T19:00:00.000Z'),
endDate: new Date('2021-04-30T22:00:00.000Z'),
}, {
text: 'Review Changes to Health Insurance Coverage',
priorityId: 2,
startDate: new Date('2021-04-29T16:00:00.000Z'),
endDate: new Date('2021-04-29T20:00:00.000Z'),
}, {
text: 'Review Training Course for any Omissions',
priorityId: 1,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T21:00:00.000Z'),
},
];
const priorityData = [
{
text: 'Low Priority',
id: 1,
color: '#1e90ff',
}, {
text: 'High Priority',
id: 2,
color: '#ff9747',
},
];

Group Orientation
Users can group appointments by resources. This demo declares a single resource—Priority. Refer to the following demo for more information about resources and their configuration: Resources.
To group appointments by resources, specify the groups[] array. Each element of this array is the fieldExpr of a corresponding resource kind. The order of group headers in the UI is the same as items in the resource instances array. If the groups[] array contains more than one element, groups are nested.
The Scheduler can arrange group headers vertically (in a column) or horizontally (in a row). Use the views.groupOrientation property to set a custom orientation for specific views. This demo shows two Work Week views with different group orientations.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<dx-scheduler
timeZone="America/Los_Angeles"
[dataSource]="appointmentsData"
currentView="Vertical Grouping"
[currentDate]="currentDate"
[startDayHour]="9"
[endDayHour]="16"
[groups]="['priorityId']"
[showCurrentTimeIndicator]="false"
[showAllDayPanel]="false"
[crossScrollingEnabled]="true"
>
<dxi-view
type="workWeek"
name="Vertical Grouping"
groupOrientation="vertical"
[cellDuration]="60"
[intervalCount]="2"
>
</dxi-view>
<dxi-view
type="workWeek"
name="Horizontal Grouping"
groupOrientation="horizontal"
[cellDuration]="30"
[intervalCount]="2"
>
</dxi-view>
<dxi-resource
[dataSource]="prioritiesData"
fieldExpr="priorityId"
label="Priority"
[allowMultiple]="false"
></dxi-resource>
</dx-scheduler>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxSchedulerModule } from 'devextreme-angular';
import { Appointment, Priority, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
appointmentsData: Appointment[];
currentDate: Date = new Date(2021, 3, 21);
prioritiesData: Priority[];
constructor(service: Service) {
this.appointmentsData = service.getAppointments();
this.prioritiesData = service.getPriorities();
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxSchedulerModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule {}
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
import { Injectable } from '@angular/core';
export class Appointment {
text: string;
priorityId: number;
startDate: Date;
endDate: Date;
}
export class Priority {
text: string;
id: number;
color: string;
}
const appointments: Appointment[] = [
{
text: 'Website Re-Design Plan',
priorityId: 2,
startDate: new Date('2021-04-19T16:30:00.000Z'),
endDate: new Date('2021-04-19T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 1,
startDate: new Date('2021-04-22T17:00:00.000Z'),
endDate: new Date('2021-04-22T19:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
startDate: new Date('2021-04-19T20:00:00.000Z'),
endDate: new Date('2021-04-19T22:30:00.000Z'),
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
startDate: new Date('2021-04-20T17:00:00.000Z'),
endDate: new Date('2021-04-20T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
startDate: new Date('2021-04-20T19:00:00.000Z'),
endDate: new Date('2021-04-20T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
startDate: new Date('2021-04-19T20:00:00.000Z'),
endDate: new Date('2021-04-19T22:15:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
startDate: new Date('2021-04-20T16:00:00.000Z'),
endDate: new Date('2021-04-20T19:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
startDate: new Date('2021-04-21T19:00:00.000Z'),
endDate: new Date('2021-04-21T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
startDate: new Date('2021-04-19T16:00:00.000Z'),
endDate: new Date('2021-04-19T18:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
startDate: new Date('2021-04-22T18:00:00.000Z'),
endDate: new Date('2021-04-22T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
startDate: new Date('2021-04-21T18:00:00.000Z'),
endDate: new Date('2021-04-21T20:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
startDate: new Date('2021-04-23T17:00:00.000Z'),
endDate: new Date('2021-04-23T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
startDate: new Date('2021-04-23T16:00:00.000Z'),
endDate: new Date('2021-04-23T22:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
startDate: new Date('2021-04-23T23:30:00.000Z'),
endDate: new Date('2021-04-24T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
startDate: new Date('2021-04-23T19:20:00.000Z'),
endDate: new Date('2021-04-23T21:00:00.000Z'),
}, {
text: 'Google AdWords Strategy',
priorityId: 1,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T19:00:00.000Z'),
}, {
text: 'Rollout of New Website and Marketing Brochures',
priorityId: 1,
startDate: new Date('2021-04-26T20:00:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Non-Compete Agreements',
priorityId: 2,
startDate: new Date('2021-04-27T20:00:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Approve Hiring of John Jeffers',
priorityId: 2,
startDate: new Date('2021-04-27T16:00:00.000Z'),
endDate: new Date('2021-04-27T19:00:00.000Z'),
}, {
text: 'Update NDA Agreement',
priorityId: 1,
startDate: new Date('2021-04-27T18:00:00.000Z'),
endDate: new Date('2021-04-27T21:15:00.000Z'),
}, {
text: 'Update Employee Files with New NDA',
priorityId: 1,
startDate: new Date('2021-04-30T16:00:00.000Z'),
endDate: new Date('2021-04-30T18:45:00.000Z'),
}, {
text: 'Submit Questions Regarding New NDA',
priorityId: 1,
startDate: new Date('2021-04-28T17:00:00.000Z'),
endDate: new Date('2021-04-28T18:30:00.000Z'),
}, {
text: 'Submit Signed NDA',
priorityId: 1,
startDate: new Date('2021-04-28T20:00:00.000Z'),
endDate: new Date('2021-04-28T22:00:00.000Z'),
}, {
text: 'Review Revenue Projections',
priorityId: 2,
startDate: new Date('2021-04-28T18:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Comment on Revenue Projections',
priorityId: 2,
startDate: new Date('2021-04-26T17:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Provide New Health Insurance Docs',
priorityId: 2,
startDate: new Date('2021-04-30T19:00:00.000Z'),
endDate: new Date('2021-04-30T22:00:00.000Z'),
}, {
text: 'Review Changes to Health Insurance Coverage',
priorityId: 2,
startDate: new Date('2021-04-29T16:00:00.000Z'),
endDate: new Date('2021-04-29T20:00:00.000Z'),
}, {
text: 'Review Training Course for any Omissions',
priorityId: 1,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T21:00:00.000Z'),
},
];
const prioritiesData: Priority[] = [
{
text: 'Low Priority',
id: 1,
color: '#1e90ff',
}, {
text: 'High Priority',
id: 2,
color: '#ff9747',
},
];
@Injectable()
export class Service {
getAppointments() {
return appointments;
}
getPriorities() {
return prioritiesData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49',
'devextreme-angular': 'npm:devextreme-angular@23.1.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.6/*/package.json',
'npm:devextreme-angular@23.1.6/ui/*/package.json',
'npm:devextreme-angular@23.1.6/package.json',
'npm:devexpress-diagram@2.2.2/package.json',
'npm:devexpress-gantt@4.1.49/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Group Orientation
Users can group appointments by resources. This demo declares a single resource—Priority. Refer to the following demo for more information about resources and their configuration: Resources.
To group appointments by resources, specify the groups[] array. Each element of this array is the fieldExpr of a corresponding resource kind. The order of group headers in the UI is the same as items in the resource instances array. If the groups[] array contains more than one element, groups are nested.
The Scheduler can arrange group headers vertically (in a column) or horizontally (in a row). Use the views.groupOrientation property to set a custom orientation for specific views. This demo shows two Work Week views with different group orientations.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<template>
<DxScheduler
time-zone="America/Los_Angeles"
:data-source="dataSource"
:groups="groups"
:current-date="currentDate"
:start-day-hour="9"
:end-day-hour="16"
:cross-scrolling-enabled="true"
:show-all-day-panel="false"
:current-view="currentView"
>
<DxView
:cell-duration="60"
:interval-count="2"
type="workWeek"
name="Vertical Grouping"
group-orientation="vertical"
/>
<DxView
:cell-duration="30"
:interval-count="2"
type="workWeek"
name="Horizontal Grouping"
/>
<DxResource
:allow-multiple="false"
:data-source="priorityData"
field-expr="priorityId"
label="Priority"
/>
</DxScheduler>
</template>
<script>
import { DxScheduler, DxResource, DxView } from 'devextreme-vue/scheduler';
import { data, priorityData } from './data.js';
export default {
components: {
DxScheduler,
DxResource,
DxView,
},
data() {
return {
currentView: 'Vertical Grouping',
groups: ['priorityId'],
currentDate: new Date(2021, 3, 21),
dataSource: data,
priorityData,
};
},
};
</script>
<style scoped>
.dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const data = [
{
text: 'Website Re-Design Plan',
priorityId: 2,
startDate: new Date('2021-04-19T16:30:00.000Z'),
endDate: new Date('2021-04-19T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 1,
startDate: new Date('2021-04-22T17:00:00.000Z'),
endDate: new Date('2021-04-22T19:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
startDate: new Date('2021-04-19T20:00:00.000Z'),
endDate: new Date('2021-04-19T22:30:00.000Z'),
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
startDate: new Date('2021-04-20T17:00:00.000Z'),
endDate: new Date('2021-04-20T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
startDate: new Date('2021-04-20T19:00:00.000Z'),
endDate: new Date('2021-04-20T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
startDate: new Date('2021-04-19T20:00:00.000Z'),
endDate: new Date('2021-04-19T22:15:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
startDate: new Date('2021-04-20T16:00:00.000Z'),
endDate: new Date('2021-04-20T19:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
startDate: new Date('2021-04-21T19:00:00.000Z'),
endDate: new Date('2021-04-21T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
startDate: new Date('2021-04-19T16:00:00.000Z'),
endDate: new Date('2021-04-19T18:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
startDate: new Date('2021-04-22T18:00:00.000Z'),
endDate: new Date('2021-04-22T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
startDate: new Date('2021-04-21T18:00:00.000Z'),
endDate: new Date('2021-04-21T20:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
startDate: new Date('2021-04-23T17:00:00.000Z'),
endDate: new Date('2021-04-23T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
startDate: new Date('2021-04-23T16:00:00.000Z'),
endDate: new Date('2021-04-23T22:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
startDate: new Date('2021-04-23T23:30:00.000Z'),
endDate: new Date('2021-04-24T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
startDate: new Date('2021-04-23T19:20:00.000Z'),
endDate: new Date('2021-04-23T21:00:00.000Z'),
}, {
text: 'Google AdWords Strategy',
priorityId: 1,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T19:00:00.000Z'),
}, {
text: 'Rollout of New Website and Marketing Brochures',
priorityId: 1,
startDate: new Date('2021-04-26T20:00:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Non-Compete Agreements',
priorityId: 2,
startDate: new Date('2021-04-27T20:00:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Approve Hiring of John Jeffers',
priorityId: 2,
startDate: new Date('2021-04-27T16:00:00.000Z'),
endDate: new Date('2021-04-27T19:00:00.000Z'),
}, {
text: 'Update NDA Agreement',
priorityId: 1,
startDate: new Date('2021-04-27T18:00:00.000Z'),
endDate: new Date('2021-04-27T21:15:00.000Z'),
}, {
text: 'Update Employee Files with New NDA',
priorityId: 1,
startDate: new Date('2021-04-30T16:00:00.000Z'),
endDate: new Date('2021-04-30T18:45:00.000Z'),
}, {
text: 'Submit Questions Regarding New NDA',
priorityId: 1,
startDate: new Date('2021-04-28T17:00:00.000Z'),
endDate: new Date('2021-04-28T18:30:00.000Z'),
}, {
text: 'Submit Signed NDA',
priorityId: 1,
startDate: new Date('2021-04-28T20:00:00.000Z'),
endDate: new Date('2021-04-28T22:00:00.000Z'),
}, {
text: 'Review Revenue Projections',
priorityId: 2,
startDate: new Date('2021-04-28T18:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Comment on Revenue Projections',
priorityId: 2,
startDate: new Date('2021-04-26T17:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Provide New Health Insurance Docs',
priorityId: 2,
startDate: new Date('2021-04-30T19:00:00.000Z'),
endDate: new Date('2021-04-30T22:00:00.000Z'),
}, {
text: 'Review Changes to Health Insurance Coverage',
priorityId: 2,
startDate: new Date('2021-04-29T16:00:00.000Z'),
endDate: new Date('2021-04-29T20:00:00.000Z'),
}, {
text: 'Review Training Course for any Omissions',
priorityId: 1,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T21:00:00.000Z'),
},
];
export const priorityData = [
{
text: 'Low Priority',
id: 1,
color: '#1e90ff',
}, {
text: 'High Priority',
id: 2,
color: '#ff9747',
},
];
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'root:': '../../../../../',
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'root:utils/demo-ts-loader.js',
'svg-loader': 'root:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-vue': 'npm:devextreme-vue@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

Pull down to refresh...
Release to refresh...
Refreshing...
-
Data Grid
- Overview
-
Data Binding
-
Paging and Scrolling
-
Editing
-
Grouping
-
Filtering and Sorting
- Focused Row
-
Row Drag & Drop
-
Selection
-
Columns
- State Persistence
-
Appearance
-
Templates
-
Data Summaries
-
Master-Detail
-
Export to PDF
-
Export to Excel
-
Adaptability
- Keyboard Navigation
-
Pivot Grid
- Overview
-
Data Binding
-
Field Chooser
-
Features
-
Export to Excel
-
Tree List
- Overview
-
Data Binding
- Sorting
- Paging
-
Editing
- Node Drag & Drop
- Focused Row
-
Selection
-
Filtering
-
Column Customization
- State Persistence
- Adaptability
- Keyboard Navigation
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Features
- Virtual Scrolling
-
Grouping
-
Customization
- Adaptability
-
Html Editor
-
Chat
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
Charts
- Overview
-
Data Binding
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Line Charts
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
-
Sparkline Charts
-
Tree Map
-
Funnel and Pyramid Charts
- Sankey Chart
-
Combinations
-
More Features
-
Export
-
Selection
-
Tooltips
-
Zooming
-
-
Gantt
- Overview
-
Data
-
UI Customization
- Strip Lines
- Export to PDF
- Sorting
-
Filtering
-
Gauges
- Overview
-
Data Binding
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Navigation
- Overview
- Accordion
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
- Pagination
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
- Resizable
-
-
Editors
- Overview
- Autocomplete
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Drop Down Box
-
Number Box
-
Select Box
- Switch
-
Tag Box
- Text Area
- Text Box
- Validation
- Custom Text Editor Buttons
- Right-to-Left Support
- Editor Appearance Variants
-
Forms and Multi-Purpose
- Overview
- Button Group
- Field Set
-
Filter Builder
-
Form
- Radio Group
-
Range Selector
- Numeric Scale (Lightweight)
- Numeric Scale
- Date-Time Scale (Lightweight)
- Date-Time Scale
- Logarithmic Scale
- Discrete scale
- Custom Formatting
- Use Range Selection for Calculation
- Use Range Selection for Filtering
- Image on Background
- Chart on Background
- Customized Chart on Background
- Chart on Background with Series Template
- Range Slider
- Slider
-
Sortable
-
File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Actions and Lists
- Overview
-
Action Sheet
-
Button
- Floating Action Button
- Drop Down Button
-
Context Menu
-
List
-
Lookup
-
Maps
- Overview
-
Map
-
Vector Map
-
Dialogs and Notifications
-
Localization
Related Demos:
Your search did not match any results.
Loading...
React Scheduler - Group Orientation
Users can group appointments by resources. This demo declares a single resource—Priority. Refer to the following demo for more information about resources and their configuration: Resources.
To group appointments by resources, specify the groups[] array. Each element of this array is the fieldExpr of a corresponding resource kind. The order of group headers in the UI is the same as items in the resource instances array. If the groups[] array contains more than one element, groups are nested.
To give you the ability to edit code on the fly, the demo uses SystemJS. For this reason, launching the demo takes some time. We strongly recommend that you do not use this approach in real projects.
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
x
import React from 'react';
import Scheduler, { Resource, View } from 'devextreme-react/scheduler';
import { data, priorityData } from './data.ts';
const currentDate = new Date(2021, 3, 21);
const groups = ['priorityId'];
const App = () => (
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
groups={groups}
defaultCurrentView={'Vertical Grouping'}
defaultCurrentDate={currentDate}
startDayHour={9}
endDayHour={16}
crossScrollingEnabled={true}
showAllDayPanel={false}
>
<View
name="Vertical Grouping"
type="workWeek"
groupOrientation="vertical"
cellDuration={60}
intervalCount={2}
/>
<View
name="Horizontal Grouping"
type="workWeek"
cellDuration={30}
intervalCount={2}
/>
<Resource
fieldExpr="priorityId"
allowMultiple={false}
dataSource={priorityData}
label="Priority"
/>
</Scheduler>
);
export default App;
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
xxxxxxxxxx
The Scheduler can arrange group headers vertically (in a column) or horizontally (in a row). Use the views.groupOrientation property to set a custom orientation for specific views. This demo shows two Work Week views with different group orientations.